#include <unistd.h>

#define ABBREVCODE '#'
#define BIBPATHVAR "BIBINPUTS"
#define FIELDLEFT '{'		/* can be either '{' or '"' */
#define FIELDRIGHT '}'		/* can be either '}' or '"' */
#define CLIPFILE "/tmp/bibcard.clip.bib"

typedef struct ref {
char ref_type[80];
char *field[24];
char open_char[25];
char close_char[25];
char *annote;
char *nsfield;
struct ref *next;
struct ref *prev;
} Reference, *Ref;
 
typedef struct sl {
char *selection;
struct sl *next;
} SL, *SLIST;

extern SLIST select_list;



extern bt_window1_objects   *bt_window1;
extern bt_listpop_objects	*bt_listpop;
extern bt_loadpop_objects	*bt_loadpop;
extern bt_savepop_objects	*bt_savepop;
extern bt_findpop_objects	*bt_findpop;
extern bt_annotepop_objects	*bt_annotepop;
extern bt_stringpop_objects	*bt_stringpop;
extern bt_nspop_objects	*bt_nspop;
extern bt_expand_objects	*bt_expand;
extern bt_sortpop_objects	*bt_sortpop;
extern bt_clip_pop_objects	*bt_clip_pop;

extern char pathname[MAXPATHLEN], filename[MAXPATHLEN];
extern char * strdup();

extern Ref current_item, last_item, first_item;
extern int mod_flag, sort_flag;

#define LD_ERROR 98

extern char * strdup();
extern char * realloc();
#define set_str(x, new)\
    	if (x) free(x); \
	 if (new) x = strdup(new); \
	else x = new

#define add_to(x,s)\
	if (!x) {set_str(x,s);} \
	else if (s) { \
		x = realloc(x,strlen(x)+strlen(s)+1); \
		strcat(x,s); \
	}


int		SELECTION_PRINT;
FILE * infile;
Ref  *aux, *ptr1, *ptr2, ref, prev;
extern int    inum,total,sort_count,oldval;
extern int 	MERGE_FLAG;
extern int last_field, edit_count;
extern char * preamble;
